Codeforces-696B Puzzles

Barney lives in country USC (United States of Charzeh). USC has n cities numbered from 1 through n and n - 1 roads between them. Cities and roads of USC form a rooted tree (Barney's not sure why it is rooted). Root of the tree is the city number 1. Thus if one will start his journey from city 1, he can visit any city he wants by following roads.

Some girl has stolen Barney's heart, and Barney wants to find her. He starts looking for in the root of the tree and (since he is Barney Stinson not a random guy), he uses a random DFS to search in the cities. A pseudo code of this algorithm is as follows:

let starting_time be an array of length n
current_time = 0
dfs(v):
	current_time = current_time + 1
	starting_time[v] = current_time
	shuffle children[v] randomly (each permutation with equal possibility)
	// children[v] is vector of children cities of city v
	for u in children[v]:
		dfs(u)

As told before, Barney will start his journey in the root of the tree (equivalent to call dfs(1)).

Now Barney needs to pack a backpack and so he wants to know more about his upcoming journey: for every city i, Barney wants to know the expected value of starting_time[i]. He's a friend of Jon Snow and knows nothing, that's why he asked for your help.

Input

The first line of input contains a single integer n (1 ≤ n ≤ 105) — the number of cities in USC.

The second line contains n - 1 integers p2, p3, ..., pn (1 ≤ pi < i), where pi is the number of the parent city of city number i in the tree, meaning there is a road between cities numbered pi and i in USC.

Output

In the first and only line of output print n numbers, where i-th number is the expected value of starting_time[i].

Your answer for each city will be considered correct if its absolute or relative error does not exceed 10 - 6.

Examples
input
7
1 2 1 1 4 4
output
1.0 4.0 5.0 3.5 4.5 5.0 5.0 
input
12
1 1 2 2 4 4 3 3 1 10 8
output
1.0 5.0 5.5 6.5 7.5 8.0 8.0 7.0 7.5 6.5 7.5 8.0 
题目大意:

给你一棵树,问你从根走到最后一个节点,最早到达每个节点的期望,从父亲节点到儿子节点的顺序是随机的,也就是有n!种可能。

解题思路:

假设num[i]表示i节点的后代的个数,v表示i节点的儿子节点,ans[i]表示i节点的期望。可以先手动把题目样例计算几遍,然后会发现,ans[v] = ans[i] + 1 + (num[i] - num[v] - 1) / 2;

为了计算这个我算了一个半天+一个上午0.0啊我还是太弱了= =

以下是ac代码:

#include <cstdio>
#include <vector>
#include <cstring>
using namespace std;
const int maxn = 1e5 + 5;
int n, val;
int num[maxn];
double ans[maxn];
vector<int> vec[maxn];

void dfs(int p){
	int len = vec[p].size();
	num[p] = len;
	for(int i = 0; i < len; ++i){
		int v = vec[p][i];
		dfs(v);
		num[p] += num[v];
	}
}
void cal(int p){
	int len = vec[p].size();
	for(int i = 0; i < len; ++i){
		int v = vec[p][i];
		ans[v] = ans[p] + 1 + (num[p] - num[v] - 1) / 2.0;
		cal(v);
	}
}
int main()
{
	// freopen("test.in", "r+", stdin);
	// freopen("test.out", "w+", stdout);
	scanf("%d", &n);
	for(int i = 0; i <= n; ++i) {
		vec[i].clear();
		num[i] = 0;
	}
	for(int i = 2; i <= n; ++i){
		scanf("%d", &val);
		vec[val].push_back(i);
	}
	dfs(1);
	ans[1] = 1;
	cal(1);
	for(int i = 1; i <= n; ++i){
		if(i != 1) printf(" ");
		printf("%.8f", ans[i]);
	}
	return 0;
}



原文地址:https://www.cnblogs.com/wiklvrain/p/8179465.html